<?php 
// Copyright David Wilkinson 2000 - 2001. All Rights reserved.

/* BrewBlogger includes David's entire script here, although much of it is not used.  Future functionality
   may possibly use the unused functions. Thanks to Chris "Floyd" Kreutzer for finding this script and 
   integrating it into BrewBlogger. */
   
class Calendar
{
    /*
        Constructor for the Calendar class
    */
    function Calendar()
    {
    }
    
    
    /*
        Get the array of strings used to label the days of the week. This array contains seven 
        elements, one for each day of the week. The first entry in this array represents Sunday. 
    */
    function getDayNames()
    {
        return $this->dayNames;
    }
    

    /*
        Set the array of strings used to label the days of the week. This array must contain seven 
        elements, one for each day of the week. The first entry in this array represents Sunday. 
    */
    function setDayNames($names)
    {
        $this->dayNames = $names;
    }
    
    /*
        Get the array of strings used to label the months of the year. This array contains twelve 
        elements, one for each month of the year. The first entry in this array represents January. 
    */
    function getMonthNames()
    {
        return $this->monthNames;
    }
    
    /*
        Set the array of strings used to label the months of the year. This array must contain twelve 
        elements, one for each month of the year. The first entry in this array represents January. 
    */
    function setMonthNames($names)
    {
        $this->monthNames = $names;
    }
    
    /* 
        Gets the start day of the week. This is the day that appears in the first column
        of the calendar. Sunday = 0.
    */
      function getStartDay()
    {
        return $this->startDay;
    }
    
    /* 
        Sets the start day of the week. This is the day that appears in the first column
        of the calendar. Sunday = 0.
    */
    function setStartDay($day)
    {
        $this->startDay = $day;
    }
    
    
    /* 
        Gets the start month of the year. This is the month that appears first in the year
        view. January = 1.
    */
    function getStartMonth()
    {
        return $this->startMonth;
    }
    
    /* 
        Sets the start month of the year. This is the month that appears first in the year
        view. January = 1.
    */
    function setStartMonth($month)
    {
        $this->startMonth = $month;
    }
    
    
    /*
        Return the URL to link to in order to display a calendar for a given month/year.
        You must override this method if you want to activate the "forward" and "back" 
        feature of the calendar.
        
        Note: If you return an empty string from this function, no navigation link will
        be displayed. This is the default behaviour.
        
        If the calendar is being displayed in "year" view, $month will be set to zero.
    */
    function getCalendarLink($month, $year)
    {
		$filter = "all";
		if (isset($_GET['filter'])) {
  		$filter = (get_magic_quotes_gpc()) ? $_GET['filter'] : addslashes($_GET['filter']);
		}
    	$s = getenv('SCRIPT_NAME');
        return "$s?page=calendar&filter=".$filter."&month=$month&year=$year";
    }
    
    /*
        Return the URL to link to  for a given date.
        You must override this method if you want to activate the date linking
        feature of the calendar.
        
        Note: If you return an empty string from this function, no navigation link will
        be displayed. This is the default behaviour.
    */
    function getDateLink($day, $month, $year)
    {
       //  return "index.php?view=day&day=$day&month=$month&year=$year";
		return 0;
    }
	
	function getDateContent($day, $month, $year, $small = 0) {
		global $brewCalendarArray;

		$use_date = date('Y-m-d', mktime(0,0,0,$month,$day,$year));
	//	echo ($use_date); 

	//	print_r($brewCalendarArray[$use_date]);
		
		$event_length = 16;
		
	//	if($small) {
	//		$display_events = 1;
	//	} else {
			$display_events = 5;
	//	}
		if(isset($brewCalendarArray[$use_date])) {	
			$count = sizeof($brewCalendarArray[$use_date]);
		} else {
			$count = 0;
		}
		if($count) {
			$content =  "<table border=0 cellspacing=0 cellpadding=0 width=100%>";
			$curr_event = 0;
			while ($curr_event < $count) { // && $curr_event < $display_events) {
				$short_disp =  $brewCalendarArray[$use_date][$curr_event][1] . ": " . $brewCalendarArray[$use_date][$curr_event][0] ;
				$content .= "<tr><td align=\"left\"><span class=\"calendarContent\">\n";
				$content .= "<a href=\"index.php?page=brewBlogDetail&filter=". $brewCalendarArray[$use_date][$curr_event][3] ."&id=" . $brewCalendarArray[$use_date][$curr_event][2] . "\"\n";
				$content .= " class=\"calendarContent\">"; 
				$content .= substr($short_disp,0,$event_length);
				$content .= "</a>"; 
				$content .= "</span></td></tr>";
				$curr_event++;				
			}
			
	/*		if ($curr_event == $display_events) { //  && $curr_event < $num_events) {
				$content .= "<tr><td align=right valign=bottom><span class=\"calendarContent\">\n";
				
				$content .= "<a href=\"\" onmouseover=\"showLayer('" . $month . "/" . $day . "/" . $year . "')\"\n";
				$content .= " onmouseout=\"hideLayer('" . $month . "/" . $day . "/" . $year . "')\" class=\"calendarContent\">";
				$content .= "<img src=\"calendar/images/more.gif\" border=0>";
				$content .= "</a>"; 
				$content .= "</span></td></tr>";
			}
	*/		
			$content .= "</table>";
		} else {
			$content = "";
		}
		return $content;
	}
	
	function createDayEventLayers($d,$m,$y) {
		$layers = "";
		$a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];  
		$date = $year . "-" . $month . "-" . $d;
		$events_select_query = "select appointment_id
									 , subject
									 , start_time
									 , end_time 
									 , show_as
								from calendar 
								where start_date ='" . $date . "'
								and int_user_id = " . USERID;		
		$events_select_result = pg_exec($events_select_query);
		$num_events = pg_numRows($events_select_result);
		if ($num_events) {			
			$pos = 0;
			while($pos < $num_events) {
				$row = pg_fetch_row($events_select_result,$pos);	
				$start_ampm = "am";
				$end_ampm = "am";
				$start_time_array = split(':',$row[2]);
				if ($start_time_array[0] >= 12) {
					$start_ampm = "pm";
					$start_time_array[0] = $start_time_array[0] - 12;
				}
				if ($start_time_array[0] == 0) $start_time_array[0] = 12;
				$end_time_array = split(':',$row[3]);
				if ($end_time_array[0] >= 12) {
					$end_ampm = "pm";
					$end_time_array[0] = $end_time_array[0] - 12;
				}
				if ($end_time_array[0] == 0) $end_time_array[0] = 12;
				$long_disp =  "$start_time_array[0]:$start_time_array[1]$start_ampm - $end_time_array[0]:$end_time_array[1]$end_ampm $row[1]";
				$layers .= "<div id=\"" . $row[0] . "\" style=\"position:absolute; visibility:hidden; border-width:2px; border-color:black; background:white\">";
				$layers .= "<table border=0 cellspacing=0 cellpadding=0><tr><td><table border=0 cellspacing=0 cellpadding=0 bgcolor=ffffff><tr><td><span class=\"calendarContent\">";
				$layers .= $long_disp;
				$layers .= "</span></td></tr></table></td></tr></table>";
				$layers .= "</div>";				
				$pos++;
				
			}		
		
		}					
		
		return $layers;
	}
	function createMonthEventLayers($m,$y) {
	
		$layers = "";
		$a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];     
		   

    	$daysInMonth = $this->getDaysInMonth($month, $year);
		
		$d = 1;
		
		while ($d <= $daysInMonth) {
			// check to see if any events for this day
			$date = $year . "-" . $month . "-" . $d;
			$events_select_query = "select appointment_id, subject, start_time, end_time from calendar where start_date ='" . $date . "' and int_user_id = " . USERID
							. " order by start_time";
			$events_select_result = pg_exec($events_select_query);
			$num_events = pg_numRows($events_select_result);	
			$curr_event = 0;
			if($num_events) {
				
				$layers .= "<div id=\"" . $month . "/" . $d . "/" . $year . "\" style=\"position:absolute; visibility:hidden; border-width:1px; border-color:black;\">";
				$layers .= "<table border=0 cellspacing=0 cellpadding=0>";
				$layers .= "<tr>";
				$layers .= "<td valign=top>";
				$layers .= "<table cellspacing=0 cellpadding=0 border=0 width=100%>";
				
				$use_bgcolor = 1;
				while($curr_event < $num_events) {
					if($use_bgcolor == 1) {
						$bgcolor= ROWCOLOR1;
						$use_bgcolor=0;		
					} else {
						$bgcolor= ROWCOLOR2;
						$use_bgcolor=1;
					}
					$event_info = pg_fetch_row($events_select_result,$curr_event);
					$start_ampm = "am";
					$end_ampm = "am";
					$start_time_array = split(':',$event_info[2]);
					if ($start_time_array[0] >= 12) {
						$start_ampm = "pm";
						$start_time_array[0] = $start_time_array[0] - 12;
					}
					if ($start_time_array[0] == 0) $start_time_array[0] = 12;
					$end_time_array = split(':',$event_info[3]);
					if ($end_time_array[0] >= 12) {
						$end_ampm = "pm";
						$end_time_array[0] = $end_time_array[0] - 12;
					}
					if ($end_time_array[0] == 0) $end_time_array[0] = 12;
					$long_disp =  "$start_time_array[0]:$start_time_array[1]$start_ampm - $end_time_array[0]:$end_time_array[1]$end_ampm $event_info[1]";
			    	$layers .= "<tr bgcolor=" . $bgcolor . ">";
					$layers .= "<td nowrap><div class=\"InfoText\">";
					$layers .= "&nbsp;" . $long_disp . "&nbsp;";
					$layers .="</div></td></tr>";
					$curr_event++;
				}
				$layers .= "</table></td></tr></table></div>\n";
				
				$curr_event = 0;
				while($curr_event < $num_events) {
					$event_info = pg_fetch_row($events_select_result,$curr_event);
					$start_ampm = "am";
					$end_ampm = "am";
					$start_time_array = split(':',$event_info[2]);
					if ($start_time_array[0] >= 12) {
						$start_ampm = "pm";
						$start_time_array[0] = $start_time_array[0] - 12;
					}
					if ($start_time_array[0] == 0) $start_time_array[0] = 12;
					$end_time_array = split(':',$event_info[3]);
					if ($end_time_array[0] >= 12) {
						$end_ampm = "pm";
						$end_time_array[0] = $end_time_array[0] - 12;
					}
					if ($end_time_array[0] == 0) $end_time_array[0] = 12;
					$long_disp =  "$start_time_array[0]:$start_time_array[1]$start_ampm - $end_time_array[0]:$end_time_array[1]$end_ampm $event_info[1]";
					$layers .= "<div id=\"" . $event_info[0] . "\" style=\"position:absolute; visibility:hidden; border-width:2px; border-color:black; background:white\">";
					$layers .= "<table border=0 cellspacing=0 cellpadding=1><tr><td><table border=0 cellspacing=0 cellpadding=0 bgcolor=ffffff><tr><td><span class=\"calendarContent\">";
					$layers .= $long_disp;
					$layers .= "</span></td></tr></table></td></tr></table>";
					$layers .= "</div>";
					$curr_event++;
				}
			}		
				
			$d++;
		}
		
		
		return $layers;
	}

    /*
        Return the HTML for the current month
    */
    function getCurrentMonthView()
    {
        $d = getdate(time());
        return $this->getMonthView($d["mon"], $d["year"]);
    }
    

    /*
        Return the HTML for the current year
    */
    function getCurrentYearView()
    {
        $d = getdate(time());
        return $this->getYearView($d["year"]);
    }
    
    
    /*
        Return the HTML for a specified month
    */
    function getMonthView($month, $year)
    {
        return $this->getMonthHTML($month, $year);
    }
	
    /*
        Return the HTML for a specified month
    */
    function getMonthViewSmall($month, $year)
    {
        return $this->getMonthSmallHTML($month, $year);
    }	
	
	/*
        Return the HTML for a specified day
    */
    function getDayView($day, $month, $year)
    {
        return $this->getDayHTML($day,$month, $year);
    }	
	
	/*
        Return the HTML for a specified day
    */
    function getWeekView($day, $month, $year)
    {
        return $this->getWeekHTML($day,$month, $year);
    }		


    /*
        Return the HTML for a specified year
    */
    function getYearView($year)
    {
        return $this->getYearHTML($year);
    }
    
    
    
    /********************************************************************************
    
        The rest are private methods. No user-servicable parts inside.
        
        You shouldn't need to call any of these functions directly.
        
    *********************************************************************************/


    /*
        Calculate the number of days in a month, taking into account leap years.
    */
    function getDaysInMonth($month, $year)
    {
        if ($month < 1 || $month > 12)
        {
            return 0;
        }
   
        $d = $this->daysInMonth[$month - 1];
   
        if ($month == 2)
        {
            // Check for leap year
            // Forget the 4000 rule, I doubt I'll be around then...
        
            if ($year%4 == 0)
            {
                if ($year%100 == 0)
                {
                    if ($year%400 == 0)
                    {
                        $d = 29;
                    }
                }
                else
                {
                    $d = 29;
                }
            }
        }
    
        return $d;
    }

	/* 
		Generate the HTML for a given week
	*/ 
	function getWeekHTML($d, $m, $y) {
	
		$s = "";
		
		$s .= "<table class=\"calendar\" border=\"0\" width=100%>\n";
    	$s .= "<tr>\n";
		$s .= "<td>Stop hassling me.  I will get it done.</td>";
		$s .= "</tr>\n";
		$s .= "</table>\n";
    	return $s;
	}
	
		
	/* 
		Generate the HTML for a given day
	*/ 
	function getDayHTML($d, $m, $y) {
		$s = "";
		$a = $this->adjustDate($m, $y);
		$start_disp_hour = 7;
		$end_disp_hour = 19;
        $month = $a[0];
        $year = $a[1]; 
		$events = array();
		//				        Busy     Free     Tenta   out
		$colors_array = array("0000FF","FFFFFF","FF0000","00FF00");
		
		// Setup the Events array
		$date = $year . "-" . $month . "-" . $d;
		$events_select_query = "select appointment_id
									 , subject
									 , start_time
									 , end_time 
									 , show_as
								from calendar 
								where start_date ='" . $date . "'
								and int_user_id = " . USERID
							. " order by start_time"	;
		$events_select_result = pg_exec($events_select_query);
		$num_events = pg_numRows($events_select_result);		
		
		$pos=0;
		while($pos < $num_events) {
			$row = pg_fetch_row($events_select_result,$pos);
			$start_hour = split(':',$row[2]);
			$end_hour = split(':',$row[3]);
			$start_hour[0] = $start_hour[0] + 0;
			$end_hour[0] = $end_hour[0] + 0;
			
			if($start_hour[1] > 0) {
				$topBottom = 1;
			} else {
				$topBottom = 0;
			}
			$hours = $end_hour[0] - $start_hour[0];
			if(($start_hour[1] < 30) && ($end_hour[1] >= 30)) {
				$change = .5;
			} elseif (($start_hour[1] >= 30) && ($end_hour[1] >= 30 || $end_hour[1] == 0)){
				$change = -.5;
			} else {
				$change = 0;
			}
			$duration = $hours + $change;
			
			$temp_array = array($row[0], ($row[1] . " " . $duration), $row[4],$duration,1);
			
			$events[$start_hour[0]][$topBottom][sizeof($events[$start_hour[0]][$topBottom])] = $temp_array;
			while ($duration > .5) {
				$duration = $duration - .5;
				$temp_array[4] = 0;
				$temp_array[1] = "++";
				if($topBottom == 0) {
					$topBottom = 1;
				} else {
					$start_hour[0] = $start_hour[0] + 1;
					$topBottom = 0;
				}
				$events[$start_hour[0]][$topBottom][sizeof($events[$start_hour[0]][$topBottom])] = $temp_array;
			}
			$pos++;
		}
		
		// determine the number of colums that we need
		$columns = 1;
		$pos = $start_disp_hour;
		while($pos < $end_disp_hour) {
			$temp = sizeof($events[$pos][0]);
			if ($temp > $columns) {
				$columns = $temp;
			}
			$temp = sizeof($events[$pos][1]);
			if ($temp > $columns) {
				$columns = $temp;
			}
			$pos++;
		}
		// start calendar on sunday
		$this->startDay = 0;
        
    	$daysInMonth = $this->getDaysInMonth($month, $year);
    	$date = getdate(mktime(12, 0, 0, $month, 1, $year));
    	
    	$first = $date["wday"];
    	$monthName = $this->monthNames[$month - 1];
    	$day = $this->dayNames[($this->startDay + $first - 1 + $d)%7];    	
    	    	
    	$header = $day . ", " . $monthName . " ". $d;
    	$s .= "<table class=\"calendar\" border=\"0\" width=100% cellpadding=0 cellspacing=0>\n";
    	$s .= "<tr>\n";
    	$s .= "<td align=\"center\" valign=\"bottom\" class=\"calendarHeaderMonth\" colspan=\"4\" bgcolor=ffffff>$header</td>\n";
    	$s .= "</tr>\n";
    	$s .= "<tr><td>";
		$s .= "<table bgcolor=\"c0c0c0\" width=100% border=0 cellspacing=0 cellpadding=0>";
		$curr_hour = $start_disp_hour;
		while ($curr_hour <= $end_disp_hour) {
		
			// top of the hour	
			$s .= "<tr>";
			$s .= "<td colspan=2 width=1%><img src=\"calendar/images/blank_spacer.gif\" height=1></td>";
			if (sizeof($events[$curr_hour][0]) && !$events[$curr_hour][0][0][4]) {
				$s .= "<td bgcolor=\"" . $colors_array[$events[$curr_hour][0][0][2]]. "\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4 height=1></td>";
			}	else {
				$s .= "<td bgcolor=\"ffffff\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4 height=1></td>";
				$s .= "<td colspan=\"" . $columns . "\"><img src=\"calendar/images/blank_spacer.gif\" height=1></td>";
			}			
			$s .= "</tr>";
			
			
			$s .= "<tr>";
			$s .= "<td rowspan=3 valign=top bgcolor=\"c0c0c0\" align=right class=\"calLink\">";
			if($curr_hour > 12) {
				$s .= $curr_hour - 12;
			} else {
				$s .= $curr_hour;
			}
			$s .= "</td>";
			$s .= "<td valign=top bgcolor=\"c0c0c0\" class=\"calendar\">";
			$s .= "<a href=\"\" onClick=\"addApp_popup('" . USERID . "','$d','$m','$y','$curr_hour','0');return false;\" class=\"calendarCleanLink\">";
			if($curr_hour == $start_disp_hour) {
				$s .= "am";
			} elseif ($curr_hour == 12) {
				$s .= "pm";
			} else {
				$s .= "00";
			}
			$s .= "</a></td>";
					
			if (sizeof($events[$curr_hour][0])) {
				$s .= "<td bgcolor=\"" . $colors_array[$events[$curr_hour][0][0][2]]. "\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4></td>";
				$pos = 0;
				$count = 0;
				while($pos < sizeof($events[$curr_hour][0])) {
					$count++;
					$row =$events[$curr_hour][0][$pos];
					if ($row[3] > .5) {
						$rowspan = ($row[3] * 4) - 1;
					} else {
						$rowspan = 1;
					}
					if ($row[4]) {
						$s .= "<td rowspan=" . $rowspan . " bgcolor=\"white\" class=\"calendar\" valign=top>";
						$s .= "<table border=0 cellspacing=0 cellpadding=0 width=100% height=100%><tr><td class=\"calendar\">";
						$s .= "&nbsp;<a href=\"#\" onClick=\"viewApp_popup('" . USERID . "','" . $row[0] . "');return false;\" onmouseover=\"showLayer('" . $row[0] . "')\"\n";
						$s .= " onmouseout=\"hideLayer('" . $row[0] . "')\" class=\"calendarContent\">";
						$s .= $row[1];
						$s .= "</a>";
						$s .= "</td></tr></table>";
						$s .= "</td>";
					}	
					$pos++;
				}
				if ($count < $columns) {
					$s .= "<td bgcolor=\"ffff82\" class=\"calendar\" colspan=\"" . ($columns - $count) . "\">&nbsp;";
					$s .= "</td>";
				}
			} else {
				$s .= "<td bgcolor=\"ffffff\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4></td>";
				$s .= "<td bgcolor=\"ffff82\" class=\"calendar\" colspan=\"" . $columns . "\">&nbsp;";
				$s .= "</td>";	
			}
					
			$s .= "</tr>";
			
			// bottom of the hour
			$s .= "<tr>";
			$s .= "<td><img src=\"calendar/images/blank_spacer.gif\" height=1></td>";
			if (sizeof($events[$curr_hour][1]) && !$events[$curr_hour][1][0][4]) {
				$s .= "<td bgcolor=\"" . $colors_array[$events[$curr_hour][1][0][2]]. "\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4 height=1></td>";
			}	else {
				$s .= "<td bgcolor=\"ffffff\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4 height=1></td>";
				$s .= "<td colspan=\"" . $columns . "\"><img src=\"calendar/images/blank_spacer.gif\" height=1></td>";
			}
			
			$s .= "</tr>";
			$s .= "<tr>";
			$s .= "<td valign=top bgcolor=\"c0c0c0\" class=\"calendar\">";
			$s .= "<a href=\"\" onClick=\"addApp_popup('" . USERID . "','$d','$m','$y','$curr_hour','30');return false;\" class=\"calendarCleanLink\">";
			$s .= "&nbsp;&nbsp;&nbsp;</a></td>";
			
			if (sizeof($events[$curr_hour][1])) {
				$s .= "<td bgcolor=\"" . $colors_array[$events[$curr_hour][1][0][2]]. "\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4></td>";
				$pos = 0;
				$count = 0;
				while($pos < sizeof($events[$curr_hour][1])) {
					$count++;
					$row =$events[$curr_hour][1][$pos];
					if ($row[3] > .5) {
						$rowspan = ($row[3] * 4) - 1;
					} else {
						$rowspan = 1;
					}
					if ($row[4]) {
						$s .= "<td rowspan=" . $rowspan . " bgcolor=\"white\" class=\"calendar\" valign=top>";
						$s .= "<table border=0 cellspacing=0 cellpadding=0 width=100% height=100%><tr><td class=\"calendar\">";
						$s .= "&nbsp;<a href=\"#\" onClick=\"viewApp_popup('" . USERID . "','" . $row[0] . "');return false;\" onmouseover=\"showLayer('" . $row[0] . "')\"\n";
						$s .= " onmouseout=\"hideLayer('" . $row[0] . "')\" class=\"calendarContent\">";
						$s .= $row[1];
						$s .= "</a>";
						$s .= "</td></tr></table>";
						$s .= "</td>";
					}	
					$pos++;
				}
				if ($count < $columns) {
					$s .= "<td bgcolor=\"ffff82\" class=\"calendar\" colspan=\"" . ($columns - $count) . "\">&nbsp;";
					$s .= "</td>";
				}
			} else {
				$s .= "<td bgcolor=\"ffffff\" width=1%><img src=\"calendar/images/blank_spacer.gif\" width=4></td>";
				$s .= "<td bgcolor=\"ffff82\" class=\"calendar\" colspan=\"" . $columns . "\">&nbsp;";
				$s .= "</td>";	
			} 
			$s .= "</tr>";
			$curr_hour++;
		}	
		$s .= "</table>";
		$s .= "</td></tr>";
		$s .= "</table>\n";
		$s .= $this->createDayEventLayers($d,$m,$y);
    	return $s;
	}
	
    /*
        Generate the HTML for a given month
    */
    function getMonthHTML($m, $y, $showYear = 1)
    {
		$s = "";
        
		// start calendar on sunday
		$this->startDay = 0;
		
		$height = 80;
		$halfHeight = $height / 2;
		
        $a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];        
        
    	$daysInMonth = $this->getDaysInMonth($month, $year);
    	$date = getdate(mktime(12, 0, 0, $month, 1, $year));
    	
    	$first = $date["wday"];
    	$monthName = $this->monthNames[$month - 1];
    	
    	$prev = $this->adjustDate($month - 1, $year);
    	$next = $this->adjustDate($month + 1, $year);
    	
    	if ($showYear == 1)
    	{
    	    $prevMonth = $this->getCalendarLink($prev[0], $prev[1]);
    	    $nextMonth = $this->getCalendarLink($next[0], $next[1]);
    	}
    	else
    	{
    	    $prevMonth = "";
    	    $nextMonth = "";
    	}
    	
    	$header = $monthName . (($showYear > 0) ? " " . $year : "");

// Header... contains the month and back/forward links.
    	
    	$s .= "<table class=\"calendarTitleTable\" border=\"0\" width=\"100%\" cellpadding=0 cellspacing=0>\n";
    	$s .= "<tr>\n";
    	$s .= "<td align=\"center\" valign=\"bottom\" bgcolor=ffffff>" . (($prevMonth == "") ? "&nbsp;" : "<a href=\"$prevMonth\" class=\"calLink\"><img src =\"images/arrow_left.png\" border=\"0\"></a>")  . "</td>\n";
    	$s .= "<td align=\"center\" valign=\"bottom\" class=\"calendarHeaderMonth\" colspan=\"5\" bgcolor=ffffff>$header</td>\n";
    	$s .= "<td align=\"center\" valign=\"bottom\" bgcolor=ffffff>" . (($nextMonth == "") ? "&nbsp;" : "<a href=\"$nextMonth\" class=\"calLink\"><img src =\"images/arrow_right.png\" border=\"0\"></a>")  . "</td>\n";
    	$s .= "</tr>\n";
    	
    	$s .= "<tr>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+0)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+1)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+2)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+3)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+4)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+5)%7] . "</td>\n";
    	$s .= "<td width=\"14%\"  align=\"center\" valign=\"top\" class=\"calendarHeader\">" . $this->dayNames[($this->startDay+6)%7] . "</td>\n";
    	$s .= "</tr>\n";

    	// We need to work out what date to start at so that the first appears in the correct column
    	$d = $this->startDay + 1 - $first;
    	while ($d > 1)
    	{
    	    $d -= 7;
    	}

        // Make sure we know when today is, so that we can use a different CSS style
        $today = getdate(time());
		$bgcolor_flag = 0;
    	while ($d <= $daysInMonth)
    	{
			if($bgcolor_flag) {
            	$bgcolor = "dayBG1";
                $bgcolor_flag = 0;
         	} else {
                $bgcolor = "dayBG2";
                $bgcolor_flag = 1;
          	}
    	    $s .= "<tr>\n";

    	    for ($i = 0; $i < 6; $i++)
    	    {
        	    $class = ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"]) ? "calendarToday" : $bgcolor;
    	        	$s .= "<td class=\"$class\"  valign=\"top\" height=\"$height\" width=\"14%\">";
				if ($d > 0 && $d <= $daysInMonth)
    	        {
    	            $link = $this->getDateLink($d, $month, $year);
    	            $s .= $d; // "<a href=\"index.php?view=day&day=$d&month=$month&year=$year\" class=\"calendarCleanLink\" >$d</a>";
						$s .= $this->getDateContent($d, $month, $year,0);
    	        }
    	        else
    	        {
    	            $s .= "&nbsp;";
    	        }
				
      	        $s .= "</td>\n";
        	    $d++;
    	    }
			$s .= "<td class=\"$class\"  valign=\"top\" height=\"$Height\" width=\"14%\">";
  	        if ($d > 0 && $d <= $daysInMonth)
  	        {
  	            $link = $this->getDateLink($d, $month, $year);
  	            $s .= $d; //"<a href=\"#\" class=\"calendarCleanLink\" onClick=\"addApp_popup()\">$d</a>";
				$s .= $this->getDateContent($d, $month, $year,1);
  	        }
  	        else
  	        {
  	            $s .= "&nbsp;";
  	        }
		
    	    $s .= "</td>\n";			
			$s .= "</tr>\n";
			$d++;
    	}
    	
    	$s .= "</table>\n";
  //  	$s .= $this->createMonthEventLayers($m,$y);
    	return $s;
    }

   function getMonthSmallHTML($m, $y, $showYear = 1)
    {
		$s = "";
        
		// start calendar on sunday
		$this->startDay = 0;
		
        $a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];        
        
    	$daysInMonth = $this->getDaysInMonth($month, $year);
    	$date = getdate(mktime(12, 0, 0, $month, 1, $year));
    	
    	$first = $date["wday"];
    	$monthName = $this->monthNames[$month - 1];
    	
    	$prev = $this->adjustDate($month - 2, $year);
    	$next = $this->adjustDate($month + 0, $year);
    	
    	if ($showYear == 1)
    	{
    	    $prevMonth = $this->getCalendarLink($prev[0], $prev[1]);
    	    $nextMonth = $this->getCalendarLink($next[0], $next[1]);
    	}
    	else
    	{
    	    $prevMonth = "";
    	    $nextMonth = "";
    	}
    	
    	$header = $monthName . (($showYear > 0) ? " " . $year : "");


    	
    	$s .= "<table class=\"calendar\" border=\"0\" width=100% cellspacing=3 cellpadding=0 bgcolor=\"ffffff\">\n";
    	$s .= "<tr bgcolor=\"c0c0c0\">\n";
    	$s .= "<td align=\"center\" valign=\"bottom\"class=\"calendar\" colspan=\"7\" nowrap>" . (($prevMonth == "") ? "&nbsp;" : "<a href=\"$prevMonth\" class=\"calendarCleanLink\">&lt;</a>")  . "\n";
    	$s .= "&nbsp;$header&nbsp;\n";
    	$s .= (($nextMonth == "") ? "&nbsp;" : "<a href=\"$nextMonth\" class=\"calendarCleanLink\">&gt;</a>")  . "</td>\n";
    	$s .= "</tr>\n";
    	
    	$s .= "<tr>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+0)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+1)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+2)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+3)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+4)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+5)%7] . "</th>\n";
    	$s .= "<td align=\"center\" valign=\"top\" class=\"calendar\">" . $this->dayNamesSmall[($this->startDay+6)%7] . "</th>\n";
    	$s .= "</tr>\n";
		$s .= "<tr><td colspan=7 height=1><img src=\"calendar/images/blank_spacer.gif\" width=1 height=1></td></tr>";
    	// We need to work out what date to start at so that the first appears in the correct column
    	$d = $this->startDay + 1 - $first;
    	while ($d > 1)
    	{
    	    $d -= 7;
    	}

        // Make sure we know when today is, so that we can use a different CSS style
        $today = getdate(time());
		$bgcolor_flag = 0;
    	while ($d <= $daysInMonth)
    	{
			if($bgcolor_flag) {
            	$bgcolor = "dayBG1";
                $bgcolor_flag = 0;
         	} else {
                $bgcolor = "dayBG2";
                $bgcolor_flag = 1;
          	}
    	    $s .= "<tr>\n";

    	    for ($i = 0; $i < 7; $i++)
    	    {
        	    $class = ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"]) ? "calendarToday" : "calendar";
    	        $s .= "<td class=\"$class\"  valign=\"top\">";
    	        if ($d > 0 && $d <= $daysInMonth)
    	        {
    	            $link = $this->getDateLink($d, $month, $year);
    	            $s .= (($link == "") ? $d : "<a href=\"$link\" class=\"calendarCleanLink\">$d</a>");
    	        }
    	        else
    	        {
    	            $s .= "&nbsp;";
    	        }
				
      	        $s .= "</td>\n";
        	    $d++;
    	    }
    	    $s .= "</tr>\n";    
    	}
    	
    	$s .= "</table>\n";
    	return $s;
    }

    /*
        Generate the HTML for a given year
    */
    function getYearHTML($year)
    {
        $s = "";
    	$prev = $this->getCalendarLink(0, $year - 1);
    	$next = $this->getCalendarLink(0, $year + 1);

        $s .= "<table class=\"calendar\" border=\"0\">\n";
        $s .= "<tr>";
    	$s .= "<td align=\"center\" valign=\"top\" align=\"left\">" . (($prev == "") ? "&nbsp;" : "<a href=\"$prev\">&lt;&lt;</a>")  . "</td>\n";
        $s .= "<td class=\"calendarHeader\" valign=\"top\" align=\"center\">" . (($this->startMonth > 1) ? $year . " - " . ($year + 1) : $year) ."</td>\n";
    	$s .= "<td align=\"center\" valign=\"top\" >" . (($next == "") ? "&nbsp;" : "<a href=\"$next\">&gt;&gt;</a>")  . "</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(0 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(1 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(2 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(3 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(4 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(5 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(6 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(7 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(8 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(9 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(10 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->getMonthHTML(11 + $this->startMonth, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "</table>\n";
        
        return $s;
    }

    /*
        Adjust dates to allow months > 12 and < 0. Just adjust the years appropriately.
        e.g. Month 14 of the year 2001 is actually month 2 of year 2002.
    */
    function adjustDate($month, $year)
    {
        $a = array();  
        $a[0] = $month;
        $a[1] = $year;
        
        while ($a[0] > 12)
        {
            $a[0] -= 12;
            $a[1]++;
        }
        
        while ($a[0] <= 0)
        {
            $a[0] += 12;
            $a[1]--;
        }
        
        return $a;
    }

    /* 
        The start day of the week. This is the day that appears in the first column
        of the calendar. Sunday = 0.
    */
    var $startDay = 0;

    /* 
        The start month of the year. This is the month that appears in the first slot
        of the calendar in the year view. January = 1.
    */
    var $startMonth = 1;

    /*
        The labels to display for the days of the week. The first entry in this array
        represents Sunday.
    */
    var $dayNames = array("Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday");
	var $dayNamesSmall = array("S","M","T","W","R","F","S");
    
    /*
        The labels to display for the months of the year. The first entry in this array
        represents January.
    */
    var $monthNames = array("January", "February", "March", "April", "May", "June",
                            "July", "August", "September", "October", "November", "December");
                            
                            
    /*
        The number of days in each month. You're unlikely to want to change this...
        The first entry in this array represents January.
    */
    var $daysInMonth = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);


}
 
 require("js_includes/calendar.js");

$date = getdate(time());
if (!isset($day)) {
	$day = $date["mday"];
}
if (!isset($month)) {
	$month = $date["mon"];
} 
if (!isset($year)) {
	$year = $date["year"];
}
$cal = new Calendar();
$cal->setStartDay(0);
$months = $cal->getMonthNames();
$monthName = $months[$month-1];
 ?>
<!-- <link rel="stylesheet" href="calendar/styles.css" type="text/css"> -->
<!-- Top Menu -->

<?php if ($row_pref['mode'] == "2") { ?>
<form name="form" id="form">
<table class="dataTable">
<tr>
	<td class="dataLabelWide" nowrap width="5%">Filter By Member:</td>
    <td class="data">
      <select name="jumpMenu" id="jumpMenu" onchange="MM_jumpMenu('parent',this,0)">
        <option value="index.php?page=calendar" <?php if ($filter == "all") echo "SELECTED"; ?>>Club Brewing Calendar</option>
        <?php do { ?>
        <option value="index.php?page=calendar&filter=<?php echo $row_members['user_name']; ?>" <?php if ($row_members['user_name'] == $filter) echo "SELECTED"; ?>><?php echo $row_members['realFirstName']." ".$row_members['realLastName']; ?></option>
        <?php } while ($row_members = mysql_fetch_assoc($members)); ?> 
      </select>
    </td>
</tr>
</table>
</form>
<?php } ?>
<table class="calendarTable" border="0" cellpadding="0" cellspacing="0">
<tr>
	<td valign="top"><?php  echo  $cal->getMonthView($month,$year);  ?></td>
</tr>
</table>
